diff --git a/gcc/ira.c b/gcc/ira.c
index cfa287f..d086084 100644
--- a/gcc/ira.c
+++ b/gcc/ira.c
@@ -4705,25 +4705,35 @@ rest_of_handle_ira (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_ira =
+class pass_ira : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "ira",                                /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  rest_of_handle_ira,		        /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_IRA,	                        /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_do_not_ggc_collect               /* todo_flags_finish */
- }
-};
+public:
+  pass_ira(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "ira",
+		   OPTGROUP_NONE,
+		   TV_IRA,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_do_not_ggc_collect)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_ira (); }
+
+}; // class pass_ira
+
+rtl_opt_pass *
+make_pass_ira (context &ctxt)
+{
+  return new pass_ira (ctxt);
+}
 
 static unsigned int
 rest_of_handle_reload (void)
@@ -4732,22 +4742,32 @@ rest_of_handle_reload (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_reload =
+class pass_reload : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "reload",                             /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  rest_of_handle_reload,	        /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_RELOAD,	                        /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+public:
+  pass_reload(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "reload",
+		   OPTGROUP_NONE,
+		   TV_RELOAD,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_reload (); }
+
+}; // class pass_reload
+
+rtl_opt_pass *
+make_pass_reload (context &ctxt)
+{
+  return new pass_reload (ctxt);
+}
diff --git a/gcc/jump.c b/gcc/jump.c
index 9a171f4..b602415 100644
--- a/gcc/jump.c
+++ b/gcc/jump.c
@@ -139,25 +139,35 @@ cleanup_barriers (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_cleanup_barriers =
+class pass_cleanup_barriers : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "barriers",                           /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  cleanup_barriers,                     /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_cleanup_barriers(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "barriers",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return cleanup_barriers (); }
+
+}; // class pass_cleanup_barriers
+
+rtl_opt_pass *
+make_pass_cleanup_barriers (context &ctxt)
+{
+  return new pass_cleanup_barriers (ctxt);
+}
 
 
 /* Initialize LABEL_NUSES and JUMP_LABEL fields, add REG_LABEL_TARGET
diff --git a/gcc/loop-init.c b/gcc/loop-init.c
index 92d621e..04b8a5b 100644
--- a/gcc/loop-init.c
+++ b/gcc/loop-init.c
@@ -302,25 +302,35 @@ gate_handle_loop2 (void)
     } 
 }
 
-struct rtl_opt_pass pass_loop2 =
+class pass_loop2 : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "loop2",                              /* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_handle_loop2, 		        /* gate */
-  NULL,                                 /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_LOOP,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_loop2(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "loop2",
+		   OPTGROUP_LOOP,
+		   TV_LOOP,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_loop2 (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+}; // class pass_loop2
+
+rtl_opt_pass *
+make_pass_loop2 (context &ctxt)
+{
+  return new pass_loop2 (ctxt);
+}
 
 
 /* Initialization of the RTL loop passes.  */
@@ -339,25 +349,35 @@ rtl_loop_init (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_rtl_loop_init =
+class pass_rtl_loop_init : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "loop2_init",                           /* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  rtl_loop_init,                        /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_LOOP,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_rtl_sharing               /* todo_flags_finish */
- }
-};
+public:
+  pass_rtl_loop_init(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "loop2_init",
+		   OPTGROUP_LOOP,
+		   TV_LOOP,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rtl_loop_init (); }
+
+}; // class pass_rtl_loop_init
+
+rtl_opt_pass *
+make_pass_rtl_loop_init (context &ctxt)
+{
+  return new pass_rtl_loop_init (ctxt);
+}
 
 
 /* Finalization of the RTL loop passes.  */
@@ -380,26 +400,35 @@ rtl_loop_done (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_rtl_loop_done =
+class pass_rtl_loop_done : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "loop2_done",                          /* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  rtl_loop_done,                        /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_LOOP,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  PROP_loops,                           /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_flow
-    | TODO_verify_rtl_sharing           /* todo_flags_finish */
- }
-};
+public:
+  pass_rtl_loop_done(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "loop2_done",
+		   OPTGROUP_LOOP,
+		   TV_LOOP,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(PROP_loops)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_flow | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rtl_loop_done (); }
+
+}; // class pass_rtl_loop_done
+
+rtl_opt_pass *
+make_pass_rtl_loop_done (context &ctxt)
+{
+  return new pass_rtl_loop_done (ctxt);
+}
 
 
 /* Loop invariant code motion.  */
@@ -417,26 +446,35 @@ rtl_move_loop_invariants (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_rtl_move_loop_invariants =
+class pass_rtl_move_loop_invariants : public rtl_opt_pass
+{
+public:
+  pass_rtl_move_loop_invariants(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "loop2_invariant",
+		   OPTGROUP_LOOP,
+		   TV_LOOP_MOVE_INVARIANTS,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_verify | TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_rtl_move_loop_invariants (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rtl_move_loop_invariants (); }
+
+}; // class pass_rtl_move_loop_invariants
+
+rtl_opt_pass *
+make_pass_rtl_move_loop_invariants (context &ctxt)
 {
- {
-  RTL_PASS,
-  "loop2_invariant",                    /* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_rtl_move_loop_invariants,        /* gate */
-  rtl_move_loop_invariants,             /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_LOOP_MOVE_INVARIANTS,              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_verify |
-  TODO_df_finish | TODO_verify_rtl_sharing  /* todo_flags_finish */
- }
-};
+  return new pass_rtl_move_loop_invariants (ctxt);
+}
 
 
 /* Loop unswitching for RTL.  */
@@ -454,25 +492,35 @@ rtl_unswitch (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_rtl_unswitch =
+class pass_rtl_unswitch : public rtl_opt_pass
+{
+public:
+  pass_rtl_unswitch(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "loop2_unswitch",
+		   OPTGROUP_LOOP,
+		   TV_LOOP_UNSWITCH,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_rtl_unswitch (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rtl_unswitch (); }
+
+}; // class pass_rtl_unswitch
+
+rtl_opt_pass *
+make_pass_rtl_unswitch (context &ctxt)
 {
- {
-  RTL_PASS,
-  "loop2_unswitch",                      /* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_rtl_unswitch,                    /* gate */
-  rtl_unswitch,                         /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_LOOP_UNSWITCH,                     /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_rtl_sharing,              /* todo_flags_finish */
- }
-};
+  return new pass_rtl_unswitch (ctxt);
+}
 
 
 /* Loop unswitching for RTL.  */
@@ -503,25 +551,35 @@ rtl_unroll_and_peel_loops (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_rtl_unroll_and_peel_loops =
+class pass_rtl_unroll_and_peel_loops : public rtl_opt_pass
+{
+public:
+  pass_rtl_unroll_and_peel_loops(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "loop2_unroll",
+		   OPTGROUP_LOOP,
+		   TV_LOOP_UNROLL,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_rtl_unroll_and_peel_loops (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rtl_unroll_and_peel_loops (); }
+
+}; // class pass_rtl_unroll_and_peel_loops
+
+rtl_opt_pass *
+make_pass_rtl_unroll_and_peel_loops (context &ctxt)
 {
- {
-  RTL_PASS,
-  "loop2_unroll",                        /* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_rtl_unroll_and_peel_loops,       /* gate */
-  rtl_unroll_and_peel_loops,            /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_LOOP_UNROLL,                       /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_rtl_sharing,              /* todo_flags_finish */
- }
-};
+  return new pass_rtl_unroll_and_peel_loops (ctxt);
+}
 
 
 /* The doloop optimization.  */
@@ -545,22 +603,32 @@ rtl_doloop (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_rtl_doloop =
+class pass_rtl_doloop : public rtl_opt_pass
+{
+public:
+  pass_rtl_doloop(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "loop2_doloop",
+		   OPTGROUP_LOOP,
+		   TV_LOOP_DOLOOP,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_rtl_doloop (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rtl_doloop (); }
+
+}; // class pass_rtl_doloop
+
+rtl_opt_pass *
+make_pass_rtl_doloop (context &ctxt)
 {
- {
-  RTL_PASS,
-  "loop2_doloop",                        /* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_rtl_doloop,                      /* gate */
-  rtl_doloop,                           /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_LOOP_DOLOOP,                       /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_rtl_sharing               /* todo_flags_finish */
- }
-};
+  return new pass_rtl_doloop (ctxt);
+}
diff --git a/gcc/lower-subreg.c b/gcc/lower-subreg.c
index eb22d8c..09cd898 100644
--- a/gcc/lower-subreg.c
+++ b/gcc/lower-subreg.c
@@ -1689,43 +1689,62 @@ rest_of_handle_lower_subreg2 (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_lower_subreg =
+class pass_lower_subreg : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "subreg1",	                        /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_lower_subreg,             /* gate */
-  rest_of_handle_lower_subreg,          /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_LOWER_SUBREG,                      /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_flow                      /* todo_flags_finish */
- }
-};
+public:
+  pass_lower_subreg(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "subreg1",
+		   OPTGROUP_NONE,
+		   TV_LOWER_SUBREG,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_lower_subreg (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_lower_subreg (); }
+
+}; // class pass_lower_subreg
+
+rtl_opt_pass *
+make_pass_lower_subreg (context &ctxt)
+{
+  return new pass_lower_subreg (ctxt);
+}
 
-struct rtl_opt_pass pass_lower_subreg2 =
+class pass_lower_subreg2 : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "subreg2",	                        /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_lower_subreg,             /* gate */
-  rest_of_handle_lower_subreg2,          /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_LOWER_SUBREG,                      /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  TODO_verify_flow                      /* todo_flags_finish */
- }
-};
+public:
+  pass_lower_subreg2(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "subreg2",
+		   OPTGROUP_NONE,
+		   TV_LOWER_SUBREG,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_lower_subreg (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_lower_subreg2 (); }
+
+}; // class pass_lower_subreg2
+
+rtl_opt_pass *
+make_pass_lower_subreg2 (context &ctxt)
+{
+  return new pass_lower_subreg2 (ctxt);
+}
diff --git a/gcc/lto-streamer-out.c b/gcc/lto-streamer-out.c
index f9184c3..a0fea80 100644
--- a/gcc/lto-streamer-out.c
+++ b/gcc/lto-streamer-out.c
@@ -1004,34 +1004,61 @@ lto_output (void)
 #endif
 }
 
-struct ipa_opt_pass_d pass_ipa_lto_gimple_out =
+class pass_ipa_lto_gimple_out : public ipa_opt_pass_d
 {
- {
-  IPA_PASS,
-  "lto_gimple_out",	                /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_lto_out,			        /* gate */
-  NULL,		                	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_IPA_LTO_GIMPLE_OUT,		        /* tv_id */
-  0,	                                /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,            			/* todo_flags_start */
-  0                                     /* todo_flags_finish */
- },
- NULL,		                        /* generate_summary */
- lto_output,           			/* write_summary */
- NULL,		         		/* read_summary */
- lto_output,           			/* write_optimization_summary */
- NULL,					/* read_optimization_summary */
- NULL,					/* stmt_fixup */
- 0,					/* TODOs */
- NULL,			                /* function_transform */
- NULL					/* variable_transform */
-};
+public:
+  pass_ipa_lto_gimple_out(context &ctxt)
+    : ipa_opt_pass_d(ctxt,
+		     "lto_gimple_out",
+		     OPTGROUP_NONE,
+		     TV_IPA_LTO_GIMPLE_OUT,
+		     pass_properties(required(0),
+				     provided(0),
+				     destroyed(0)),
+		     pass_todo_flags(start(0),
+				     finish(0)),
+		     0) /* function_transform_todo_flags_start */
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_lto_out (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+  /* ipa_opt_pass_d methods: */
+  bool has_generate_summary () { return false; }
+  void impl_generate_summary () { }
+
+  bool has_write_summary () { return true; }
+  void impl_write_summary () { lto_output (); }
+
+  bool has_read_summary () { return false; }
+  void impl_read_summary () { }
+
+  bool has_write_optimization_summary () { return true; }
+  void impl_write_optimization_summary () { lto_output (); }
+
+  bool has_read_optimization_summary () { return false; }
+  void impl_read_optimization_summary () { }
+
+  bool has_stmt_fixup () { return false; }
+  void impl_stmt_fixup (struct cgraph_node *, gimple *) { }
+
+  bool has_function_transform () { return false; }
+  unsigned int impl_function_transform (struct cgraph_node *) { return 0; }
+
+  bool has_variable_transform () { return false; }
+  void impl_variable_transform (struct varpool_node *) { }
+
+}; // class pass_ipa_lto_gimple_out
+
+ipa_opt_pass_d *
+make_pass_ipa_lto_gimple_out (context &ctxt)
+{
+  return new pass_ipa_lto_gimple_out (ctxt);
+}
 
 
 /* Write each node in encoded by ENCODER to OB, as well as those reachable
@@ -1459,31 +1486,58 @@ produce_asm_for_decls (void)
 }
 
 
-struct ipa_opt_pass_d pass_ipa_lto_finish_out =
+class pass_ipa_lto_finish_out : public ipa_opt_pass_d
 {
- {
-  IPA_PASS,
-  "lto_decls_out",	                /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_lto_out,			        /* gate */
-  NULL,        	                        /* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_IPA_LTO_DECL_OUT,		        /* tv_id */
-  0,	                                /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,            			/* todo_flags_start */
-  0                                     /* todo_flags_finish */
- },
- NULL,		                        /* generate_summary */
- produce_asm_for_decls,			/* write_summary */
- NULL,		         		/* read_summary */
- produce_asm_for_decls,			/* write_optimization_summary */
- NULL,					/* read_optimization_summary */
- NULL,					/* stmt_fixup */
- 0,					/* TODOs */
- NULL,			                /* function_transform */
- NULL					/* variable_transform */
-};
+public:
+  pass_ipa_lto_finish_out(context &ctxt)
+    : ipa_opt_pass_d(ctxt,
+		     "lto_decls_out",
+		     OPTGROUP_NONE,
+		     TV_IPA_LTO_DECL_OUT,
+		     pass_properties(required(0),
+				     provided(0),
+				     destroyed(0)),
+		     pass_todo_flags(start(0),
+				     finish(0)),
+		     0) /* function_transform_todo_flags_start */
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_lto_out (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+  /* ipa_opt_pass_d methods: */
+  bool has_generate_summary () { return false; }
+  void impl_generate_summary () { }
+
+  bool has_write_summary () { return true; }
+  void impl_write_summary () { produce_asm_for_decls (); }
+
+  bool has_read_summary () { return false; }
+  void impl_read_summary () { }
+
+  bool has_write_optimization_summary () { return true; }
+  void impl_write_optimization_summary () { produce_asm_for_decls (); }
+
+  bool has_read_optimization_summary () { return false; }
+  void impl_read_optimization_summary () { }
+
+  bool has_stmt_fixup () { return false; }
+  void impl_stmt_fixup (struct cgraph_node *, gimple *) { }
+
+  bool has_function_transform () { return false; }
+  unsigned int impl_function_transform (struct cgraph_node *) { return 0; }
+
+  bool has_variable_transform () { return false; }
+  void impl_variable_transform (struct varpool_node *) { }
+
+}; // class pass_ipa_lto_finish_out
+
+ipa_opt_pass_d *
+make_pass_ipa_lto_finish_out (context &ctxt)
+{
+  return new pass_ipa_lto_finish_out (ctxt);
+}
diff --git a/gcc/mode-switching.c b/gcc/mode-switching.c
index 2bcb154..0803fad 100644
--- a/gcc/mode-switching.c
+++ b/gcc/mode-switching.c
@@ -777,23 +777,32 @@ rest_of_handle_mode_switching (void)
 }
 
 
-struct rtl_opt_pass pass_mode_switching =
+class pass_mode_switching : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "mode_sw",                            /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_mode_switching,                  /* gate */
-  rest_of_handle_mode_switching,        /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_MODE_SWITCH,                       /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_mode_switching(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "mode_sw",
+		   OPTGROUP_NONE,
+		   TV_MODE_SWITCH,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | 0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_mode_switching (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_mode_switching (); }
+
+}; // class pass_mode_switching
+
+rtl_opt_pass *
+make_pass_mode_switching (context &ctxt)
+{
+  return new pass_mode_switching (ctxt);
+}
diff --git a/gcc/modulo-sched.c b/gcc/modulo-sched.c
index 6ce79a9..6bb58e0 100644
--- a/gcc/modulo-sched.c
+++ b/gcc/modulo-sched.c
@@ -3351,24 +3351,32 @@ rest_of_handle_sms (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_sms =
-{
- {
-  RTL_PASS,
-  "sms",                                /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_sms,                      /* gate */
-  rest_of_handle_sms,                   /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_SMS,                               /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish
-    | TODO_verify_flow
-    | TODO_verify_rtl_sharing           /* todo_flags_finish */
- }
-};
+class pass_sms : public rtl_opt_pass
+{
+public:
+  pass_sms(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "sms",
+		   OPTGROUP_NONE,
+		   TV_SMS,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_flow | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_sms (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_sms (); }
+
+}; // class pass_sms
+
+rtl_opt_pass *
+make_pass_sms (context &ctxt)
+{
+  return new pass_sms (ctxt);
+}
